#ifndef incdefinesH
#define incdefinesH

#define __USE_GNU
#define _GNU_SOURCE

#define dob   double
#define elif  else if
#define uchar unsigned char
#define schar signed char
#define u32  uint32_t
#define s32   int32_t
#define u16  uint16_t
#define s16   int16_t
#define u8   uint8_t
#define s8    int8_t
#define T(S) typeof(S)
#define S(S) sizeof(S)
#define ustrlen(A)          strlen((char*)(A))
#define ustrcmp(A,B)        strcmp((char*)(A),(char*)(B))
#define ustrncmp(A,B,C)     strncmp((char*)(A),(char*)(B),C)
#define ustrcpy(A,B)        strcpy((char*)(A),(char*)(B))
#define ustpcpy(A,B)        (void*)stpcpy((char*)(A),(char*)(B))
#define ustrncpy(A,B,C)     strncpy((char*)(A),(char*)(B),C)
#define uvsnprintf(A,B,C,D) vsnprintf((char*)(A),B,(char*)C,D)

#define t(   MSG, args...) { printf("%s: "MSG"\n", __func__, ##args ); }
#define v(   MSG, args...) if( verbose     ){ t( MSG, ##args ); }
#define vv(  MSG, args...) if( verbose > 1 ){ t( MSG, ##args ); }
#define vvv( MSG, args...) if( verbose > 2 ){ t( MSG, ##args ); }
#define vvvv(MSG, args...) if( verbose > 3 ){ t( MSG, ##args ); }
#define w(   MSG, args...) t("WARNING: "MSG, ##args );
#define e(   MSG, args...) t("ERROR: "MSG,  ##args );
#define ex(  MSG, args...) e( MSG, ##args ) ; exit(0);
#define es(  MSG, args...) t("ERROR: "MSG" :%s\n", ##args , strerror(errno) );
#define esx( MSG, args...) es( MSG, ##args ); exit(0);
#define rog( MSG, args...) rotalog("%s: "MSG, __func__, ##args );
#define rogs(MSG, args...) rotalog("%s: "MSG": %s", __func__, ##args, strerror(errno) );

#define uQualifyFilename(A)		 (uchar*)QualifyFilename(A)

#define INVALID				 -1
#define VERYMUCH			 0xFFFFFFF
#define BADMATCH			 0xFFFF
#define SQFF				 0xFE01

#include <stdint.h>
#include <sys/types.h>	 /* has ulong and uint as typedef, and select() so must include it */
#include <stdlib.h>	 /* exit()	 */
#include <errno.h>	 /* errno	 */
#include <stdio.h>	 /* printf()	 */
#include <string.h>	 /* strerror()	 */

#endif
