
/*----------------- extern --------------------------------------------------------------*/

#include "defines.h"
#include "myincludesT.h" /* orgb	 */
#include "myincludes.h"	 /* ckalloc()	 */

extern int	 verbose				 ; /* myincludes.c */
extern int	 winwi, winhi				 ; /* main.c	 */
extern orgb*	 imor					 ; /* imobuf.c	 */
extern orgb	 drawcolor				 ; /* main.c	 */
extern int	 imoaffx1, imoaffx2, imoaffy1, imoaffy2	 ; /* imobuf.c	 */

/*----------------- filescope -----------------------------------------------------------*/

#define DIDSETCANFILL 4
#define CANFILL 2
#define TAG 1

static uchar*	 tagmap				 ;
static int	 tagmapsize			 ;
static int	 tagmaplinesize			 ;
static int	 mintaglinix, maxtaglinix	 ;

/*----------------- AllocTagmap ---------------------------------------------------------*/

void AllocTagmap( void ){ /* this is an init function */
  if( tagmap != NULL ){ ex("already alloced"); }
  tagmapsize = winhi * winwi * sizeof(uchar) ;
  tagmap = (uchar*) ckalloc( tagmapsize );
  tagmaplinesize = winwi * sizeof( uchar ) ;
  memset( tagmap, 0, tagmapsize );
  }

/*----------------- ClearTagmap ---------------------------------------------------------*/

static void ClearTagmap( void ){ memset( tagmap, 0, tagmapsize ); }

/*----------------- SetCanfill ----------------------------------------------------------*/

static void SetCanfill( int linix ){ /* must detect when this has already been done earlier */
  T(uchar*)	 puc, puco	 ;
  orgb*		 po		 ;

  if( linix < 0 || linix > winhi - 1 ){ ex("linix out of bounds"); }
  puc = tagmap + linix * winwi ;
  if( *puc & DIDSETCANFILL ){ return ; }
  *puc |= DIDSETCANFILL ;
  puco = puc + winwi ;
  po = imor + linix * winwi ;
  for( ; puc < puco ; puc++, po++ ){
    if( (po->r) & (po->g) & (po->b) & 128 ){ *puc |= CANFILL ; }
    }	 /* N*45 */
  }

/*----------------- SetTagsFrombelow ----------------------------------------------------*/

static int SettagsFrombelow( int linix ){ /* returns count */
  T(uchar*)	 puc, puco, puc2 ;
  int		 count		 ;

  if( linix < 0 || linix > winhi - 1 ){ ex("linix out of bounds"); }
  count = 0 ;
  puc = tagmap + linix * winwi ;
  if( ! (*puc & DIDSETCANFILL) ){ ex("canfill not filled in"); }
  puco = puc + winwi ;
  puc2 = puco ;
  for( ; puc < puco ; puc++, puc2++ ){					 /* .35 */
    if( (*puc2 & TAG) && (!(*puc & TAG)) && (*puc & CANFILL) ){
      *puc |= TAG ; count++ ;
      }									 /* 52 */
    }
  return( count );
  }

/*----------------- SetTagsFromabove ----------------------------------------------------*/

static int SettagsFromabove( int linix ){ /* returns count */
  T(uchar*)	 puc, puco, puc2 ;
  int		 count		 ;

  if( linix < 0 || linix > winhi - 1 ){ ex("linix out of bounds"); }
  count = 0 ;
  puc = tagmap + linix * winwi ;
  if( ! (*puc & DIDSETCANFILL) ){ ex("canfill not filled in"); }
  puco = puc + winwi ;
  puc2 = puc - winwi ;
  for( ; puc < puco ; puc++, puc2++ ){
    if( (*puc2 & TAG) && (!(*puc & TAG)) && (*puc & CANFILL) ){ *puc |= TAG ; count++ ; }
    }
  return( count );
  }

/*----------------- SetTagsFromleft -----------------------------------------------------*/

static int SettagsFromleft( int linix ){ /* returns count */
  T(uchar*)	 puc, pucl	 ;
  int		 count		 ;
  int		 prevtag	 ;

  if( linix < 0 || linix > winhi - 1 ){ ex("linix out of bounds"); }
  count = 0 ;
  puc  = tagmap + linix * winwi ;
  pucl = puc + (winwi - 1) ;
  if( ! (*puc & DIDSETCANFILL) ){ ex("canfill not filled in"); }
  prevtag = 0 ;
  for( ; puc <= pucl ; puc++ ){
    if( *puc & TAG ){ prevtag = 1 ; continue ; }
    if( prevtag && (*puc & CANFILL) ){ *puc |= TAG ; count++ ; prevtag = 1 ; }
    else                             { prevtag = 0 ; }
    }
  return( count );
  }

/*----------------- SetTagsFromright ----------------------------------------------------*/

static int SettagsFromright( int linix ){ /* returns count */
  T(uchar*)	 puc, pucl	 ;
  int		 count		 ;
  int		 prevtag	 ;

  if( linix < 0 || linix > winhi - 1 ){ ex("linix out of bounds"); }
  count = 0 ;
  pucl = tagmap + linix * winwi ;
  puc  = pucl + (winwi - 1) ;
  if( ! (*pucl & DIDSETCANFILL) ){ ex("canfill not filled in"); }
  prevtag = 0 ;
  for( ; puc >= pucl ; puc-- ){
    if( *puc & TAG ){ prevtag = 1 ; continue ; }
    if( prevtag && (*puc & CANFILL) ){ *puc |= TAG ; count++ ; prevtag = 1 ; }
    else                             { prevtag = 0 ; }
    }
  return( count );
  }

/*----------------- FillTagged ----------------------------------------------------------*/

static void FillTagged( void ){ /* updates imo with drawcolor whereever a tag is set */
  int		 y, x		 ;
  T(uchar*)	 linpt, pt		 ;
  T(orgb*)	 linpo, po		 ;
  uchar		 ndro			 ;
  int16_t	 mintagx, maxtagx	 ;
  int16_t	 mintagy, maxtagy	 ;
  uint16_t	 v, dro, dgo, dbo, doo	 ;

  if( mintaglinix > maxtaglinix ){ w("nothing to do"); return ; }
  if( mintaglinix >= winwi || maxtaglinix >= winwi ){ e("linix too high"); return ; }
  if( mintaglinix <  0     || maxtaglinix <  0     ){ e("linix negative"); return ; }

  mintagy = mintaglinix ; maxtagy = maxtaglinix ;
  mintagx = winwi ; maxtagx = -1 ;

  linpt = tagmap + winwi * mintagy ;
  linpo = imor   + winwi * mintagy ;

  if( drawcolor.o != 255 ){
    ndro = 0xFF - drawcolor.o ;
    dro = drawcolor.r * drawcolor.o ;
    dgo = drawcolor.g * drawcolor.o ;
    dbo = drawcolor.b * drawcolor.o ;
    doo = drawcolor.o * 255 ;
    for( y=mintagy ; y <= maxtagy ; y++,linpt+=winwi,linpo+=winwi ){
      for( x=0,pt=linpt,po=linpo ; x < winwi ; x++,pt++,po++ ){
        if( ! (*pt & TAG) ){ continue ; }
        if( mintagx > x ){ mintagx = x ; }
        if( maxtagx < x ){ maxtagx = x ; }
      
        v = dro + po->r * ndro ; v += (v>>8) ; po->r = v>>8 ;
        v = dgo + po->g * ndro ; v += (v>>8) ; po->g = v>>8 ;
        v = dbo + po->b * ndro ; v += (v>>8) ; po->b = v>>8 ;
        v = doo + po->o * ndro ; v += (v>>8) ; po->o = v>>8 ;
        }
      }
    }
  else { /* fully opaque drawcolor */
    for( y=mintagy ; y <= maxtagy ; y++,linpt+=winwi,linpo+=winwi ){
      for( x=0,pt=linpt,po=linpo ; x < winwi ; x++,pt++,po++ ){
        if( ! (*pt & TAG) ){ continue ; }
        if( mintagx > x ){ mintagx = x ; }
        if( maxtagx < x ){ maxtagx = x ; }
        *po = drawcolor ;
        }
      }
    }

  vvv("mintagx=%d maxtagx=%d mintagy=%d maxtagy=%d",mintagx, maxtagx, mintagy, maxtagy );
  vvv("imoaffx1=%d imoaffx2=%d imoaffy1=%d imoaffy2=%d",imoaffx1,imoaffx2,imoaffy1,imoaffy2 );
  if( imoaffx1 > mintagx ){ imoaffx1 = mintagx ; }
  if( imoaffx2 < maxtagx ){ imoaffx2 = maxtagx ; }
  if( imoaffy1 > mintagy ){ imoaffy1 = mintagy ; }
  if( imoaffy2 < maxtagy ){ imoaffy2 = maxtagy ; }
  vvv("imoaffx1=%d imoaffx2=%d imoaffy1=%d imoaffy2=%d",imoaffx1,imoaffx2,imoaffy1,imoaffy2 );
  }

/*----------------- SetTags -------------------------------------------------------------*/

static int SetTags( int x, int y ){
  int	 did, didsome, count		 ;
  orgb*	 po				 ;
  int	 yy				 ;
  uchar* puc				 ;

  if( y < 0 || y >= winhi || x < 0 || x > winwi ){ ex("invalid arg"); }
  po = imor + (y * winwi + x) * sizeof(orgb) ;
  if( ! ((po->r) & (po->g) & (po->b) & 128) ){ e("target pixel not fillable"); return(0); }
  ClearTagmap();
  SetCanfill( y );
  puc = tagmap + y * tagmaplinesize + x ;
  if( ! (*puc & CANFILL) ){ e("target pixel not marked as fillable"); return(0); }
  *puc |= TAG ; did = 1 ;
  did += SettagsFromleft(  y );
  did += SettagsFromright( y );
  didsome = count = did ;
  mintaglinix = maxtaglinix = y ;

  while( didsome ){ didsome = 0 ;
    for( yy=maxtaglinix-1 ; yy > 0 ; yy-- ){ /* fill upward */
      SetCanfill( yy );
      did = SettagsFrombelow( yy );
      if( did ){
        count += did ; didsome = 1 ;
        count += SettagsFromleft(  yy );
        count += SettagsFromright( yy );
        }
      if( yy < mintaglinix ){ if( did > 0 ){ mintaglinix = yy ; } else { break ; } }
      }
    for( yy=mintaglinix+1 ; yy < winhi ; yy++ ){ /* fill downward */
      SetCanfill( yy );
      did = SettagsFromabove( yy );
      if( did ){
        count += did ; didsome = 1 ;
        count += SettagsFromleft(  yy );
        count += SettagsFromright( yy );
        }
      if( yy > maxtaglinix ){ if( did > 0 ){ maxtaglinix = yy ; } else { break ; } }
      }
    }
  v("tagged %d pixels", count );
  return( count );
  }

/*----------------- CountArea -----------------------------------------------------------*/

int CountArea( int x, int y ){ return( SetTags( x, y ) ); }

/*----------------- FillArea ------------------------------------------------------------*/

int FillArea( int x, int y ){ /* needs imobuftoximage and renderximage to become visible */
  int count ;
  count = SetTags( x, y );
  FillTagged();			 /* fills to imobuf. not to ximage ! */
  return( count );
  }

