#ifndef incmyincludesTH
#define incmyincludesTH

/* this header is included by users of myincludes.h and by myincludes.c */

/*----------------- typedef ----------------------------------------------------------------*/

typedef struct FilebufS {
  char*	 name		 ; /* if filebuffer associated with file, then contains fqfilename. */
			   /*   else must be some identifying string.			 */
  uchar	 nameisprivate	 ; /* name was malloced by GetFilebuf ; free it @discard filebuf */
  uchar	 hasfile	 ; /* 1 if filebuffer is associated with a file, else 0 .	 */
  uchar	 ismmapped	 ; /* bool. mmapped=1 malloced=0.				 */
  uchar	 isshared	 ; /* bool. mmappedprivate=0; mmappedshared=1; not mmapped=garbage */
  uchar	 iswritable	 ; /* 1: was opened rw for 1st read. 0: was opened r for 1st read. */
			   /* indicates how filebuffer is supposed to be used.		 */
  void*	 buf		 ; /* start of storage						 */
  void*	 cont		 ; /* start of valid (gotten) content				 */
  void*	 ocont		 ; /* past gotten content					 */
  void*	 obuf		 ; /* past buf							 */
  struct FilebufS * pNext ; /* for if i want a list of filebufs */
  struct FilebufS * pPrev ;
  } Filebuf ;

typedef struct { uchar  o ; uchar  r ; uchar  g ; uchar  b ; } orgb ;

typedef struct {
  char		sig[4]		 ; /* should be 'imo0' (independent of byte-order)	 */
  uint32_t	byteorder	 ; /* should be 0x01020304				 */
  uint32_t	wi		 ;
  uint32_t	hi		 ;
  int32_t	offx		 ;
  int32_t	offy		 ;
  float		scalex		 ; /* should be float32_t but that doesn't exist.	 */
  float		scaley		 ; /* should be float32_t but that doesn't exist.	 */
  } imoheader ;

#endif
