/* PngToImo.c */

/* compile with :
pushd /my/prive/projects/Canvas/v4/util
cc PngToImo.c -oPngToImo -I/my/prive/projects/Canvas/v4/source -lpng -W -Wall
*/

/* STATUS :
  converted to use local includes. compiles. probably works.
  TODO: remove commented-out statements.
  TODO: see whether i really needed to include WriteMallocedFilebuf
    (ie: is filebuf ever private ?)
*/

/*----------------- include ------------------------------------------------------------*/

#include "defines.h"
/*
#include "defines.c"
#include "errordef.c"
*/
#include <png.h>

#include "myincludesT.h"
#include "myincludes.h"
#include "myincludes.c"
/*
#include "file/FileExists.c"
#include "file/QualifyFilename.c"
#include "file/filebuf.c"
#include "imo/orgbT.h"
#include "imo/imoheader.c"
#include "ph.c"
*/
/*----------------- globals ------------------------------------------------------------*/

char* help[] = {
  "PngToImo : read a png file and create an imo file with same imagecontent.",
  "syntax : PngToImo (-v)* $pngfilename ($imofilename)?                     ",
  "this is version 1 : all comments are ignored                             ",
  NULL } ;

T(char*)	 imofilename, pngfilename	 ;
FILE*		 ifp				 ;
Filebuf		 ofb				 ;
imoheader*	 pih				 ;
orgb*		 ro				 ;
png_structp	 ps				 ;
png_infop	 psi				 ;
png_infop	 psie				 ; /* pointer to end info */

/*----------------- FillUtilArrays -----------------------------------------------------*/

/* for verbose filetype reporting (usefull for testing) : */

char* coltyp[32] ; /* don't know how many entries */
char* ilace[4]	 ;

void FillUtilArrays( void ){
  int i ;
  i = PNG_COLOR_TYPE_PALETTE	 ; coltyp[i] = "palette"   ; vv("coltyp[%d]=%s",i,coltyp[i] );
  i = PNG_COLOR_TYPE_RGB	 ; coltyp[i] = "rgb"	   ; vv("coltyp[%d]=%s",i,coltyp[i] );
  i = PNG_COLOR_TYPE_RGB_ALPHA	 ; coltyp[i] = "rgb+alpha" ; vv("coltyp[%d]=%s",i,coltyp[i] );
  i = PNG_COLOR_TYPE_GRAY	 ; coltyp[i] = "gray"	   ; vv("coltyp[%d]=%s",i,coltyp[i] );
  i = PNG_COLOR_TYPE_GRAY_ALPHA	 ; coltyp[i] = "gray+alpha"; vv("coltyp[%d]=%s",i,coltyp[i] );

  i = PNG_INTERLACE_NONE	 ; ilace[i] = "none"	 ; vv("ilace[%d]=%s", i, ilace[i] );
  i = PNG_INTERLACE_ADAM7	 ; ilace[i] = "adam7"	 ; vv("ilace[%d]=%s", i, ilace[i] );
  }

/*----------------- ParseArguments -----------------------------------------------------*/

void ParseArguments( int argc, char** argv ){
  int	 i	 ;
  char*	 arg	 ;

  verbose = 0 ; imofilename = pngfilename = NULL ;
  for( i=1 ; i < argc ; i++ ){ arg = argv[i] ;
    if( arg[0] == '-' ){
      if( arg[1] == 'v' ){ verbose++ ; continue ; }
      if( arg[1] == 'h' ){ phe(); }
      ex("invalid option %s", arg );
      }
    if(   pngfilename == NULL ){ pngfilename = arg ; }
    elif( imofilename == NULL ){ imofilename = arg ; }
    else { e("only two filenames allowed"); phe(); }
    }

  if( pngfilename == NULL ){ e("no pngfilename specified"); phe(); }

  pngfilename = QualifyFilename( pngfilename );
  if( imofilename == NULL ){
    int len = strlen( pngfilename );
    imofilename = (char*) ckalloc( len + 5 );
    memcpy( imofilename, pngfilename, len + 1 );
    if(  0 == strncmp( imofilename + len - 4, ".png", 4 )
      || 0 == strncmp( imofilename + len - 4, ".PNG", 4 ) ){
      memcpy( imofilename + len - 4, ".imo", 4 );
      }
    else { memcpy( imofilename + len, ".imo", 4 ); }
    }
  else { imofilename = QualifyFilename( imofilename ); }

  v("pngfilename=%s imofilename=%s verbose=%d", pngfilename, imofilename, verbose );
  }

/*----------------- Cleanup -------------------------------------------------------------*/

void Cleanup( void ){
  png_destroy_read_struct( &ps, &psi, &psie );
  }

/*----------------- Convert ------------------------------------------------------------*/

/* for interlaced images i need to write entire image 7 times,			 */
/*   so i want to mmap outfile, to not have all of it in memory needlessly.	 */

/* if i can get libpng to output in my orgb format, then do that ;		 */
/*   otherwise let it output in it's own format, and i correct that later.	 */

void Convert( void ){
  orgb*		 po				 ;
  int		 wi, hi, bpc, colortype		 ;
  int		 interlace, compress, filter	 ;
  int		 numpasses			 ;
  png_color_16	 mybg				 ; /* not commandline-settable yet */
  png_color_16	 imagebg			 ; /* probably not used */
  png_color_16p	 pimagebg			 ; /* tmp */
  int		 size				 ;
  png_uint_32	 puwi, puhi			 ;
  int		 pass, rowix			 ; /* tmp */
  int		 ck				 ;

  mybg.index = 0 ;						 /* not used	 */
  mybg.red = mybg.green = mybg.blue = mybg.gray = 0xFFFF ;	 /* white	 */
  pimagebg = &imagebg ;						 /* REMOVE THIS LATER */

  /* create datastructures and error-return-address for libpng : */
  ps =  png_create_read_struct( PNG_LIBPNG_VER_STRING, NULL, NULL, NULL );
  if( ps == NULL ){ ex("nok create read struct"); }
  psi  = png_create_info_struct( ps );
  psie = png_create_info_struct( ps );
  if( psi == NULL || psie == NULL ){ Cleanup(); ex("nok create info struct"); }
  if( setjmp( png_jmpbuf(ps) )    ){ Cleanup(); ex("nok setjmp"); }

  /* first get libpng to read header, to find sizes of image : */
  if( NULL == (ifp = fopen( pngfilename, "r" )) ){
    Cleanup(); esx("nok fopen pngfile %s", pngfilename); }
  png_init_io( ps, ifp );		 /* tell libpng about infile	 */
  png_read_info( ps, psi );		 /* read file upto image data	 */
  puwi = wi ; puhi = hi ;
  png_get_IHDR( ps, psi, &puwi, &puhi, &bpc, &colortype, &interlace, &compress, &filter );
  wi = puwi ; hi = puhi ;
  if( wi <= 0 || hi <= 0 ){ Cleanup(); ex("nok wi/hi : wi=%d hi=%d", wi, hi ); }
  if( filter    != PNG_FILTER_TYPE_BASE      ){ Cleanup(); ex("invalid filter type"); }
  if( compress  != PNG_COMPRESSION_TYPE_BASE ){ Cleanup(); ex("invalid compression type"); }
  if( interlace != PNG_INTERLACE_NONE ){
    numpasses = png_set_interlace_handling( ps ); /* makes libpng handle interlace */
    }
  v("wi=%d hi=%d bitsperchannel=%d colortype=%s interlace=%s numpasses=%d",
    wi, hi, bpc, coltyp[colortype], ilace[interlace], numpasses );

  /* tell libpng which transformations it must do on input data : */

  if(   bpc == 16 ){ png_set_strip_16( ps ); } /* converts from 16 bpc to 8 bpc */
  elif( bpc <   8 ){ png_set_packing(  ps ); } /* converts to 8 bpc from lower bpc */

  if( png_get_valid( ps, psi, PNG_INFO_tRNS) ){ png_set_tRNS_to_alpha( ps ); }

  if(   colortype == PNG_COLOR_TYPE_PALETTE ){
    png_set_palette_to_rgb( ps );
    png_set_add_alpha( ps, 0xFF, PNG_FILLER_BEFORE);
    }
  elif( colortype == PNG_COLOR_TYPE_RGB ){
    png_set_add_alpha( ps, 0xFF, PNG_FILLER_BEFORE);
    }
  elif( colortype == PNG_COLOR_TYPE_RGB_ALPHA ){
    png_set_swap_alpha( ps ); /* converts rgbo to orgb ! */
    }
  elif( colortype == PNG_COLOR_TYPE_GRAY ){
    if( png_get_bKGD( ps, psi, &pimagebg) ){
           png_set_background( ps, pimagebg, PNG_BACKGROUND_GAMMA_FILE  , 1, 1.0 ); }
    else { png_set_background( ps, &mybg   , PNG_BACKGROUND_GAMMA_SCREEN, 0, 1.0 ); }
    png_set_gray_to_rgb( ps );
    png_set_add_alpha( ps, 0xFF, PNG_FILLER_BEFORE );
    }
  elif( colortype == PNG_COLOR_TYPE_GRAY_ALPHA ){
    if( png_get_bKGD( ps, psi, &pimagebg) ){
           png_set_background( ps, pimagebg, PNG_BACKGROUND_GAMMA_FILE  , 1, 1.0 ); }
    else { png_set_background( ps, &mybg   , PNG_BACKGROUND_GAMMA_SCREEN, 0, 1.0 ); }
    png_set_gray_to_rgb( ps );
    png_set_swap_alpha( ps ); /* converts rgbo to orgb ! */
    }
  else { Cleanup(); ex("invalid colortype"); }

  /* make libpng update it's infor struct (not strictly necessary) : */
  png_read_update_info( ps, psi );

  /* get filebuffer for outfile : */
  /* if file does not exist yet, it must be created, otherwise i cant ftruncate it */
  size = sizeof(imoheader) + wi * hi * sizeof(orgb) ;
  ck = FileExists( imofilename, NULL );
  if( ck > 1 ){ Cleanup(); ex("file %s exists and is not an ordinary file", imofilename ); }
  elif( ck == 0 ){
    int fh ;
    fh = open( imofilename, O_RDWR | O_CREAT, 0660 );
    if( fh <= 0 ){ Cleanup(); esx("nok open imofile %s", imofilename ); }
    if( 0 > ftruncate( fh, size ) ){
      Cleanup(); esx("nok ftruncate %s to %d", imofilename, size ); }
    if( 0 != close( fh ) ){ Cleanup(); esx("nok close new imofile %s", imofilename ); }
    }
  else {
    if( 0 != truncate( imofilename, size ) ){ Cleanup(); esx("nok truncate %s",imofilename);}
    }
  ofb = GetMmappedFilebuf( imofilename, 0 );
  pih = (imoheader*) ofb.buf ;
  ro = (orgb*) (ofb.buf + sizeof(imoheader)) ;

  /* fill in imoheader : */
  memcpy( pih->sig, "imo0", 4 );
  pih->byteorder = 0x01020304	 ;
  pih->wi	 = wi		 ; pih->hi	 = hi		 ;
  pih->offx	 = 0		 ; pih->offy	 = 0		 ;
  pih->scalex	 = (float) 1.0	 ; pih->scaley	 = (float) 1.0	 ;

  /* read rows : */
  for( pass=0 ; pass < numpasses ; pass++ ){
    po = ro ;
    for( rowix=0 ; rowix < hi ; rowix++, po+=wi ){ png_read_row( ps, (png_bytep) po, NULL ); }
    }

  /* finish read : */
  png_read_end( ps, psie ); /* psie can be null ; only usefull for trailing comments */

  Cleanup();			 /* free memory used by libpng */
  WriteMmappedFilebuf( &ofb );	 /* set filesize to size of contents, and sync */
  DiscardFilebuf( &ofb );	 /* superfluous */
  fclose( ifp );		 /* superfluous */
  }

/*----------------- main ---------------------------------------------------------------*/

int main( int argc, char** argv ){
  FillUtilArrays();
  ParseArguments( argc, argv );
  Convert();
  return(0);
  }
