/* canvassock.c : C program that sends it's argument onto socket /tmp/canvas.sock */
/* intended to be used until i know how to use sockets from perl. */

/* compile with :
pushd /my/prive/projects/Canvas/v4/util/
cc canvassock.c -o canvassock -W -Wall -I/my/prive/projects/Canvas/v4/source
popd
*/

/* STATUS : works (with canvas v4 too)
*/

#include "defines.h"

#include "myincludesT.h"
#include "myincludes.h"
#include "myincludes.c"
#include <unistd.h>
#include <sys/socket.h>		 /* socket(), bind(), listen(), accept()	 */
#include <sys/un.h>		 /* struct sockaddr_un				 */

#define READBUFSIZE 1000

char* help[] = {
  "canvassock : read drawcommands from stdin,                                     ",
  "  send them through socket /tmp/canvas.sock, read reply, and print it to stdout",
  "syntax: canvassock (-v)* $command                                              ",
  "  where each -v increases verbosity (for debugging)                            ",
  "  and $command is (usually quoted) text string to send                         ",
  "In text string, \"\n\" and ';' are replaced by '\n',                           ",
  "  so they can be used to separate drawcommands.                                ",
  NULL } ;

int main( int argc, char** argv ){
  char*			 arg		 ;
  int			 len, size, ck	 ;
  int			 sockfd		 ;
  struct sockaddr_un	 sockstructun	 ;
  uchar*		 sockfilename	 = (uchar*)"/tmp/canvas.sock" ;
  char			 readbuf[READBUFSIZE] ;
  T(char*)		 p		 ;
  char			 c		 ;

  if( argc != 2 ){ ex("argc is %d ; must be 2", argc ); }
  arg = argv[1] ;

  /* replace ';' with '\n', and replace "\n" with '\n' : */
  for( p=arg ; (c=*p) != 0 ; p++ ){
    if( c == ';' ){ *p = '\n' ; }
    if( c == '\\' && *(p+1) == 'n' ){ *p = '\n' ; *(p+1) = ' ' ; p++ ; }
    }

  /* client creates socket to connect with : */
  sockfd = socket( PF_UNIX, SOCK_STREAM, 0 );
    /* local connectable socket, using only available (nameless) protocol. */
    /* this socket by default does not have blocking mode */
  if( sockfd < 0 ){ esx("cant create socket."); }

  /* connect to server listening on socket with that filename : */
  sockstructun.sun_family = AF_UNIX ;
  strcpy( sockstructun.sun_path , (char*)sockfilename );
  size = SUN_LEN( &sockstructun );
  if( 0 > connect( sockfd, (struct sockaddr *) &sockstructun , size ) ){ esx("nok connect."); }

  len = strlen(arg);
  ck = write( sockfd, arg, len+1 );
  if( ck != len + 1 ){ e("wrote %d of %d bytes", ck, len+1 ); }

  /* wait for server to send a reply, by doing a blocking read : */
  ck = read( sockfd, readbuf, READBUFSIZE - 1 );
  if( ck < 0 ){ es("failed read."); return(-1); }
  /* no guarantee that received string is terminated, so add an extra terminator */
  readbuf[ck] = 0 ;
  if( verbose ){ t("client: got %d : %s\n", ck, readbuf ); }
  else { printf("%s\n", readbuf ); }

  if( 0 != close( sockfd ) ){ es("nok close socket"); }

  return(0);
  }
